#include <iostream>

class Person {
public:
    Person()
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    Person(std::string name)
        : name {name}
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    Person(int age)
        : age {age}
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    Person(std::string name, int age)
        : name {name}, age {age}
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
    ~Person()
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
private:
    std::string name;
    int age;
};

int main()
{
    Person p1;
    Person p2("Ionel");
    Person p3(16);
    Person p4("Ana", 17);

    Person p5{};
    Person p6 {"Ionel"};
    Person p7 {16};
    Person p8 {"Ana", 17};
}
