#include <iostream>
/// identificatori
/// int aA_23, _Aa_x3;
/// int 3a; // NU !
class Person {
public:
    Person();
    Person(std::string name);
    Person(int age);
    Person(std::string name, int age);
    ~Person();
    void Print() const;

private:
    std::string name;
    int age;
};

/// :: Scope Resolution Operator

Person::Person()
{
    std::cout << __PRETTY_FUNCTION__ << '\n';
}

Person::Person(std::string name)
    : name {name}
{
    std::cout << __PRETTY_FUNCTION__ << '\n';
}

Person::Person(int age)
    : age {age}
{
    std::cout << __PRETTY_FUNCTION__ << '\n';
}

Person::Person(std::string name, int age)
    : name {name}, age {age}
{
    std::cout << __PRETTY_FUNCTION__ << '\n';
}
Person::~Person()
{
    std::cout << __PRETTY_FUNCTION__ << '\n';
}

void Person::Print() const
{
    std::cout << name << ' ' << age << '\n';
}

int main()
{
    Person p1;
    Person p2("Ionel");
    Person p3(16);
    Person p4("Ana", 17);

    Person p5{};
    Person p6 {"Ionel"};
    Person p7 {16};
    Person p8 {"Ana", 17};
}
