#include <iostream>

class Person {
public:
    /// Declararile functiilor
    Person(std::string name = "", int age = 0)
        : name {name}, age {age}
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
    ~Person()
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

private:
    std::string name;
    int age;
};

/// Definitiile functiilor
Person::Person(std::string name, int age)
    : name {name},
      age {age}
{
    std::cout << __PRETTY_FUNCTION__ << '\n';
}

Person::~Person()
{
    std::cout << __PRETTY_FUNCTION__ << '\n';
}

int main()
{
    Person p1;
    Person p2("Ionel");
 ///   Person p3(16);
    Person p4("Ana", 17);

    Person p5{};
    Person p6 {"Ionel"};
///    Person p7 {16};
    Person p8 {"Ana", 17};
}
